=== debian/changelog ===
gnuradio (3.10.1.0-1) unstable; urgency=medium

  * New upstream release.
    Bugfixes in gr-iio, gr-uhd
    Minimal implementation of a SigMF Sink in gr-blocks

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 29 Jan 2022 10:13:12 -0500

gnuradio (3.10.1.0~rc1-1) experimental; urgency=medium

  * New upstream bug-fixing pre-release
    To unstable for C++ ABI bump, new soversion library names

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 25 Jan 2022 18:08:56 -0500

gnuradio (3.10.0.0-4) unstable; urgency=medium

  * gnuradio-dev: Add dependency on libspdlog-dev
    (instead of old liblog4cpp5-dev)

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 18 Jan 2022 16:49:09 -0500
